cookutils view cook @ rev 199

cook: add timeout to wget
author Christophe Lincoln <pankso@slitaz.org>
date Sun May 22 04:11:10 2011 +0200 (2011-05-22)
parents 273602356462
children 79ea2bf81b33
line source
1 #!/bin/sh
2 #
3 # Cook - A tool to cook and generate SliTaz packages. Read the README
4 # before adding or modifing any code in cook!
5 #
6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
7 # Author: Christophe Lincoln <pankso@slitaz.org>
8 #
10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
11 [ -f "cook.conf" ] && . ./cook.conf
13 # Share DB and status with the Cooker.
14 activity="$CACHE/activity"
15 command="$CACHE/command"
16 broken="$CACHE/broken"
17 blocked="$CACHE/blocked"
19 # Old style compatibility
20 SOURCES_REPOSITORY=$SRC
22 #
23 # Functions
24 #
26 usage() {
27 cat << EOT
29 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
31 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
32 usage|help $(gettext "Display this short usage.")
33 setup $(gettext "Setup your build environment.")
34 test $(gettext "Test environment and cook a package.")
35 list-wok $(gettext "List packages in the wok.")
36 search $(gettext "Simple packages search function.")
37 new $(gettext "Create a new package with a receipt".)
38 list $(gettext "Cook a list of packages.")
39 clean-wok $(gettext "Clean-up all packages files.")
40 clean-src $(gettext "Clean-up all packages sources.")
41 pkglist $(gettext "Create all packages.* lists.")
43 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
44 --clean|-c Cook : $(gettext "clean the package in the wok.")
45 --install|-i Cook : $(gettext "cook and install the package.")
46 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
47 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
48 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
49 --interactive Cook : $(gettext "create a receipt interactively.")
50 --wok|-w Setup: $(gettext "create also a wok from Hg repo.")
52 EOT
53 exit 0
54 }
56 # Be sure we're root.
57 check_root() {
58 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
59 }
61 separator() {
62 echo "================================================================================"
63 }
65 status() {
66 echo -en "\\033[70G[ "
67 if [ $? = 0 ]; then
68 echo -en "\\033[1;32mOK"
69 else
70 echo -en "\\033[1;31mFailed"
71 fi
72 echo -e "\\033[0;39m ]"
73 }
75 # Log activities, we want first letter capitalized.
76 log() {
77 grep ^[A-Z] | \
78 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
79 }
81 # We don't want these escapes in web interface.
82 clean_log() {
83 sed -i -e s'|\[70G\[ \[1;32m| |' \
84 -e s'|\[0;39m \]||' $LOGS/$pkg.log
85 }
87 # Log broken packages.
88 broken() {
89 if ! grep -q "^$pkg$" $broken; then
90 echo "$pkg" >> $broken
91 fi
92 }
94 # Be sure package exists in wok.
95 check_pkg_in_wok() {
96 if [ ! -d "$WOK/$pkg" ]; then
97 gettext -e "\nUnable to find package in the wok:"
98 echo -e " $pkg\n" && exit 1
99 fi
100 }
102 if_empty_value() {
103 if [ -z "$value" ]; then
104 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
105 exit 1
106 fi
107 }
109 # Initialize files used in $CACHE
110 init_db_files() {
111 gettext "Creating directories structure in:"; echo " $SLITAZ"
112 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
113 gettext "Creating DB files in:"; echo " $CACHE"
114 for f in $activity $command $broken $blocked
115 do
116 touch $f
117 done
118 }
120 # QA: check a receipt consistency before building.
121 receipt_quality() {
122 gettext -e "QA: checking package receipt...\n"
123 unset online
124 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
125 online="online"
126 fi
127 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
128 do
129 unset value
130 value=$(grep ^$var= $receipt | cut -d \" -f 2)
131 case "$var" in
132 PACKAGE|VERSION|SHORT_DESC)
133 if_empty_value ;;
134 CATEGORY)
135 [ -z "$value" ] && value="empty"
136 valid="base-system x-window utilities network graphics \
137 multimedia office development system-tools security games \
138 misc meta non-free"
139 if ! echo "$valid" | grep -q -w "$value"; then
140 gettext "QA: unknown category:"; echo -e " $value\n"
141 exit 1
142 fi ;;
143 WEB_SITE)
144 # We don't check WGET_URL since if dl is needed it will fail.
145 # Break also if we're not online. Here error is not fatal.
146 if_empty_value
147 [ -z "$online" ] || break
148 if ! busybox wget -T 12 -s $value 2>/dev/null; then
149 gettext "QA: Unable to reach:"; echo -e " $value"
150 fi ;;
151 esac
152 done
153 }
155 # Executed before sourcing a receipt.
156 unset_receipt() {
157 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
158 }
160 # Paths used in receipt and by cook itself.
161 set_paths() {
162 pkgdir=$WOK/$PACKAGE
163 src=$pkgdir/source/$PACKAGE-$VERSION
164 taz=$pkgdir/taz
165 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
166 fs=$pack/fs
167 stuff=$pkgdir/stuff
168 install=$pkgdir/install
169 if [ "$WANTED" ]; then
170 src=$WOK/$WANTED/source/$WANTED-$VERSION
171 install=$WOK/$WANTED/install
172 wanted_stuff=$WOK/$WANTED/stuff
173 fi
174 # Old way compatibility.
175 _pkg=$install
176 }
178 # Create source tarball when URL is a SCM.
179 create_tarball() {
180 gettext "Creating tarball: "; echo "$tarball"
181 if [ "$LZMA_SRC" ]; then
182 tar -c $pkgsrc | lzma e $SRC/$tarball -si || exit 1
183 else
184 tar cjf $tarball $pkgsrc || exit 1
185 mv $tarball $SRC && rm -rf $pkgsrc
186 fi
187 }
189 # Get package source. For SCM we are in cache so clone here and create a
190 # tarball here.
191 get_source() {
192 pwd=$(pwd)
193 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
194 tarball=$pkgsrc.tar.bz2
195 [ "$LZMA_SRC" ] && tarball=$pkgsrc.tar.lzma
196 case "$WGET_URL" in
197 http://*|ftp://*)
198 # Busybox Wget is better!
199 busybox wget -T 12 -c -P $SRC $WGET_URL || \
200 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
201 https://*)
202 wget -c --no-check-certificate -P $SRC $WGET_URL || \
203 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
204 hg*|mercurial*)
205 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
206 url=${WGET_URL#hg|}
207 else
208 url=${WGET_URL#mercurial|}
209 fi
210 gettext -e "Getting source from Hg...\n"
211 echo "URL: $url"
212 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
213 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
214 create_tarball ;;
215 git*)
216 url=${WGET_URL#git|}
217 gettext -e "Getting source from Git...\n"
218 echo "URL: $url"
219 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
220 if [ "$BRANCH" ]; then
221 echo "Git branch: $BRANCH"
222 cd $pkgsrc && git checkout $BRANCH && cd ..
223 fi
224 create_tarball ;;
225 cvs*)
226 url=${WGET_URL#cvs|}
227 mod=$PACKAGE
228 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
229 gettext -e "Getting source from CVS...\n"
230 echo "URL: $url"
231 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
232 gettext "Cloning to: "; echo "$pwd/$mod"
233 cvs -d:$url co $mod && mv $mod $pkgsrc
234 create_tarball ;;
235 svn*|subversion*)
236 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
237 url=${WGET_URL#svn|}
238 else
239 url=${WGET_URL#subversion|}
240 fi
241 gettext -e "Getting source from SVN...\n"
242 echo "URL: $url"
243 if [ "$BRANCH" ]; then
244 echo t | svn co $url -r $BRANCH $pkgsrc
245 else
246 echo t | svn co $url $pkgsrc
247 fi
248 create_tarball ;;
249 *)
250 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
251 tee -a $LOGS/$PACKAGE.log
252 exit 1 ;;
253 esac
254 }
256 # Extract source package.
257 extract_source() {
258 if [ ! -s "$SRC/$TARBALL" ]; then
259 local url
260 url="http://mirror.slitaz.org/sources/packages"
261 url=$url/${TARBALL:0:1}/$TARBALL
262 gettext "Getting source from mirror:"; echo " $url"
263 busybox wget -c -P $SRC $url || echo -e "ERROR: wget $url"
264 fi
265 gettext "Extracting:"; echo " $TARBALL"
266 case "$TARBALL" in
267 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
268 *.tar.bz2|*.tbz|*.tbz2) tar xjf $SRC/$TARBALL 2>/dev/null ;;
269 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
270 *.tar) tar xf $SRC/$TARBALL ;;
271 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
272 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
273 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
274 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
275 *) cp $SRC/$TARBALL $(pwd) ;;
276 esac
277 }
279 # Display cooked package summary.
280 summary() {
281 cd $WOK/$pkg
282 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
283 fs=$(du -sh taz/* | awk '{print $1}')
284 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
285 files=$(cat taz/$pkg-*/files.list | wc -l)
286 cookdate=$(date "+%Y-%m-%d %H:%M")
287 sec=$time
288 div=$(($time / 60))
289 [ "$div" != 0 ] && min="~ ${div}m"
290 gettext "Summary for:"; echo " $PACKAGE $VERSION"
291 separator
292 [ "$prod" ] && echo "Produced : $prod"
293 cat << EOT
294 Packed : $fs
295 Compressed : $size
296 Files : $files
297 Cook time : ${sec}s $min
298 Cook date : $cookdate
299 $(separator)
300 EOT
301 }
303 # Display debugging error info.
304 debug_info() {
305 echo -e "\nDebug information"
306 separator
307 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
308 for error in \
309 ERROR "No package" "cp: can't" "can't open" "can't cd" \
310 "error:" "fatal error:"
311 do
312 fgrep "$error" $LOGS/$pkg.log
313 done
314 separator && echo ""
315 }
317 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
318 # so some packages need to copy these files with the receipt and genpkg_rules.
319 copy_generic_files()
320 {
321 # $LOCALE is set in cook.conf
322 if [ "$LOCALE" ]; then
323 if [ -d "$_pkg/usr/share/locale" ]; then
324 mkdir -p $fs/usr/share/locale
325 for i in $LOCALE
326 do
327 if [ -d "$_pkg/usr/share/locale/$i" ]; then
328 cp -a $_pkg/usr/share/locale/$i $fs/usr/share/locale
329 fi
330 done
331 fi
332 fi
334 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
335 if [ "$GENERIC_PIXMAPS" != "no" ]; then
336 if [ -d "$_pkg/usr/share/pixmaps" ]; then
337 mkdir -p $fs/usr/share/pixmaps
338 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.png \
339 $fs/usr/share/pixmaps 2>/dev/null
340 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.xpm \
341 $fs/usr/share/pixmaps 2>/dev/null
342 fi
344 # Custom or homemade PNG pixmap can be in stuff.
345 if [ -f "$stuff/$PACKAGE.png" ]; then
346 mkdir -p $fs/usr/share/pixmaps
347 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
348 fi
349 fi
351 # Desktop entry (.desktop).
352 if [ -d "$_pkg/usr/share/applications" ]; then
353 cp -a $_pkg/usr/share/applications $fs/usr/share
354 fi
356 # Homemade desktop file(s) can be in stuff.
357 if [ -d "$stuff/applications" ]; then
358 mkdir -p $fs/usr/share
359 cp -a $stuff/applications $fs/usr/share
360 fi
361 if [ -f "$stuff/$PACKAGE.desktop" ]; then
362 mkdir -p $fs/usr/share/applications
363 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
364 fi
365 }
367 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
368 # as removing uneeded files like in Python packages.
369 strip_package()
370 {
371 gettext "Executing strip on all files..."
372 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
373 do
374 if [ -d "$dir" ]; then
375 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
376 fi
377 done
378 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
379 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
380 status
382 # Remove Python .pyc and .pyo from packages.
383 if echo "$PACKAGE $DEPENDS" | fgrep -q "python"; then
384 gettext "Removing Python compiled files..."
385 find $fs -type f -name "*.pyc" -delete 2>/dev/null
386 find $fs -type f -name "*.pyo" -delete 2>/dev/null
387 status
388 fi
390 # Remove Perl perllocal.pod and .packlist from packages.
391 if echo "$DEPENDS" | fgrep -q "perl"; then
392 gettext "Removing Perl compiled files..."
393 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
394 find $fs -type f -name ".packlist" -delete 2>/dev/null
395 status
396 fi
397 }
399 # Remove installed deps.
400 remove_deps() {
401 # Now remove installed build deps.
402 diff="$CACHE/installed.cook.diff"
403 if [ -s "$CACHE/installed.cook.diff" ]; then
404 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
405 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
406 gettext "Build dependencies to remove:"; echo " $nb"
407 gettext "Removing:"
408 for dep in $deps
409 do
410 echo -n " $dep"
411 yes | tazpkg remove $dep >/dev/null
412 done
413 echo -e "\n"
414 # Keep the last diff for debug and info.
415 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
416 fi
417 }
419 # The main cook function.
420 cookit() {
421 echo "Cook: $PACKAGE $VERSION"
422 separator
423 set_paths
424 [ "$QA" ] && receipt_quality
425 cd $pkgdir
426 rm -rf install taz source
428 # Disable -pipe if less than 512Mb free RAM.
429 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
430 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
431 gettext -e "Disabling -pipe compile flag: $free RAM\n"
432 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
433 CXXFLAGS="${CXXFLAGS/-pipe}" && \
434 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
435 fi
436 unset free
438 # Export flags and path to be used by make
439 DESTDIR=$pkgdir/install
440 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS BUILD_HOST CONFIG_SITE
441 local LC_ALL=POSIX LANG=POSIX
443 # Check for build deps and handle implicit depends of *-dev packages
444 # (ex: libusb-dev :: libusb).
445 cd $INSTALLED && ls -1 > $CACHE/installed.list
446 [ "$DEPENDS" ] && gettext -e "Checking build dependencies...\n"
447 for dep in $BUILD_DEPENDS
448 do
449 implicit=${dep%-dev}
450 for i in $dep $implicit
451 do
452 if [ ! -f "$INSTALLED/$i/receipt" ]; then
453 # Try local package first. In some cases implicit doesn't exist, ex:
454 # libboost-dev exists but not libboost, so check if we got vers.
455 unset vers
456 vers=$(grep ^VERSION= $WOK/$i/receipt 2>/dev/null | cut -d '"' -f 2)
457 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
458 gettext "Installing dep (pkg/local):"; echo " $i $vers"
459 cd $PKGS && tazpkg install $i-$vers.tazpkg >/dev/null
460 else
461 if [ "$vers" ]; then
462 if grep -q ^$i-$vers.tazpkg $DB/packages.list; then
463 gettext "Installing dep (web/cache):"; echo " $i $vers"
464 tazpkg get-install $i >/dev/null
465 else
466 # So package exist in wok but not available.
467 gettext "Missing dep:" ; echo " $i $vers"
468 exit 1
469 fi
470 fi
471 fi
472 fi
473 done
474 done
475 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
477 # If a cook failed deps are not removed since we exit 1.
478 [ ! -s "installed.cook.diff" ] && \
479 busybox diff installed.list installed.cook > installed.cook.diff
480 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
482 # Get source tarball and make sure we have source dir named:
483 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
484 # tarball if it exists.
485 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
486 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
487 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
488 LZMA_SRC=""
489 else
490 get_source || exit 1
491 fi
492 fi
493 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
494 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
495 extract_source || exit 1
496 if [ "$LZMA_SRC" ]; then
497 cd $pkgdir/source
498 if [ "$(ls -A tmp | wc -l)" -gl 1 ] || [ -f "$(echo tmp/*)" ]; then
499 mv tmp tmp-1 && mkdir tmp
500 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
501 fi
502 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
503 cd tmp && tar -c * | lzma e $SRC/$TARBALL -si
504 fi
505 fi
506 cd $pkgdir/source/tmp
507 # Some archives are not well done and don't extract to one dir (ex lzma).
508 files=$(ls | wc -l)
509 [ "$files" == 1 ] && mv * ../$PACKAGE-$VERSION
510 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
511 mv * ../$PACKAGE-$VERSION
512 cd .. && rm -rf tmp
513 fi
515 # Execute receipt rules.
516 if grep -q ^compile_rules $receipt; then
517 gettext -e "Executing: compile_rules\n"
518 [ -d "$src" ] && cd $src
519 compile_rules $@ || exit 1
520 # Stay compatible with _pkg
521 [ -d "$src/_pkg" ] && mv $src/_pkg $install
522 # QA: compile_rules success so valid.
523 mkdir -p $install
524 else
525 # QA: No compile_rules so no error, valid.
526 mkdir -p $install
527 fi
528 separator && echo ""
529 }
531 # Cook quality assurance.
532 cookit_quality() {
533 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
534 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
535 fi
536 # ERROR can be echoed any time in cookit()
537 if fgrep -q ERROR: $LOGS/$pkg.log; then
538 debug_info | tee -a $LOGS/$pkg.log
539 rm -f $command && exit 1
540 fi
541 }
543 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
544 # but it doesn't handle EXTRAVERSION.
545 packit() {
546 set_paths
547 echo "Pack: $PACKAGE $VERSION"
548 separator
549 if grep -q ^genpkg_rules $receipt; then
550 gettext -e "Executing: genpkg_rules\n"
551 cd $pkgdir
552 mkdir -p $fs && ( set -e; genpkg_rules ) || echo -e \
553 "\nERROR: genpkg_rules failed\n" >> $LOGS/$pkg.log
554 fi
556 # First QA check to stop now if genpkg_rules failed.
557 if fgrep -q ERROR: $LOGS/$pkg.log; then
558 exit 1
559 fi
561 cd $taz
562 for file in receipt description.txt
563 do
564 [ ! -f "../$file" ] && continue
565 gettext "Copying"; echo -n " $file..."
566 cp -f ../$file $pack && chown 0.0 $pack/$file && status
567 done
568 copy_generic_files
570 # Create files.list with redirecting find output.
571 gettext "Creating the list of files..." && cd $fs
572 find . -type f -print > ../files.list
573 find . -type l -print >> ../files.list
574 cd .. && sed -i s/'^.'/''/ files.list
575 status
577 # Strip and stuff files.
578 strip_package
580 # Md5sum of files.
581 gettext "Creating md5sum of files..."
582 while read file; do
583 [ -L "fs$file" ] && continue
584 [ -f "fs$file" ] || continue
585 case "$file" in
586 /lib/modules/*/modules.*|*.pyc) continue;;
587 esac
588 md5sum "fs$file" | sed 's/ fs/ /'
589 done < files.list > md5sum
590 status
591 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
592 description.txt 2> /dev/null | awk \
593 '{ sz=$1 } END { print sz }')
595 # Build cpio archives.
596 gettext "Compressing the fs... "
597 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
598 rm -rf fs
599 status
600 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
601 md5sum description.txt 2> /dev/null | awk \
602 '{ sz=$1 } END { print sz }')
603 gettext "Updating receipt sizes..."
604 sed -i s/^PACKED_SIZE.*$// receipt
605 sed -i s/^UNPACKED_SIZE.*$// receipt
606 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
607 status
609 # Set extra version.
610 if [ "$EXTRAVERSION" ]; then
611 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
612 sed -i s/^EXTRAVERSION.*$// receipt
613 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
614 status
615 fi
617 # Compress.
618 gettext "Creating full cpio archive... "
619 find . -print | cpio -o -H newc --quiet > \
620 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
621 status
622 gettext "Restoring original package tree... "
623 unlzma -c fs.cpio.lzma | cpio -idm --quiet
624 status
625 rm fs.cpio.lzma && cd ..
627 # QA and give info.
628 tazpkg=$(ls *.tazpkg)
629 packit_quality
630 separator && gettext "Package:"; echo -e " $tazpkg\n"
631 }
633 # Verify package quality and consistency.
634 packit_quality() {
635 #gettext "QA: Checking for broken link..."
636 #link=$(find $fs/usr -type l -follow)
637 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
638 #status
640 # Exit if any error found in log file.
641 if fgrep -q ERROR: $LOGS/$pkg.log; then
642 rm -f $command && exit 1
643 fi
645 gettext "QA: Checking for empty package..."
646 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
647 if [ "$files" -lt 0 ] && [ "$CATEGORY" != "meta" ]; then
648 echo -e "\nERROR: empty package"
649 rm -f $command && exit 1
650 else
651 # Ls sort by name so the first file is the one we want.
652 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
653 status
654 if [ -f "$old" ]; then
655 echo -n "Removing old: $(basename $old)"
656 rm -f $old && status
657 fi
658 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
659 sed -i /^${pkg}$/d $broken
660 fi
661 }
663 #
664 # Commands
665 #
667 case "$1" in
668 usage|help|-u|-h)
669 usage ;;
670 list-wok)
671 gettext -e "\nList of packages in:"; echo " $WOK"
672 separator
673 cd $WOK && ls -1
674 separator
675 echo -n "Packages: " && ls | wc -l
676 echo "" ;;
677 search)
678 # Just a simple search function, we dont need more actually.
679 query="$2"
680 gettext -e "\nSearch results for:"; echo " $query"
681 separator
682 cd $WOK && ls -1 | grep "$query"
683 separator && echo "" ;;
684 setup)
685 # Setup a build environment
686 check_root
687 echo "Cook: setting up the environment" | log
688 gettext -e "\nSetting up your environment\n"
689 separator && cd $SLITAZ
690 init_db_files
691 gettext -e "Checking for packages to install...\n"
692 for pkg in $SETUP_PKGS
693 do
694 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
695 done
697 # Handle --options
698 case "$2" in
699 --wok|-w)
700 [ ! -f "$INSTALLED/mercurial/receipt" ] && \
701 tazpkg get-install mercurial
702 [ -d "$WOK" ] && echo -e "A wok already exists.\n" && exit 1
703 hg clone $WOK_URL ;;
704 esac
706 # SliTaz group and permissions
707 if ! grep -q ^slitaz /etc/group; then
708 gettext -e "Adding group: slitaz\n"
709 addgroup slitaz
710 fi
711 gettext -e "Setting permissions for slitaz group...\n"
712 chown -R root.slitaz $SLITAZ
713 chmod -R g+w $SLITAZ
714 separator
715 gettext -e "All done, ready to cook packages :-)\n\n" ;;
716 test)
717 # Test a cook environment.
718 echo "Cook test: testing the cook environment" | log
719 [ ! -d "$WOK" ] && exit 1
720 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
721 cook cooktest ;;
722 new)
723 # Create the package folder and an empty receipt.
724 pkg="$2"
725 [ "$pkg" ] || usage
726 echo ""
727 if [ -d "$WOK/$pkg" ]; then
728 echo -n "$pkg " && gettext "package already exists."
729 echo -e "\n" && exit 1
730 fi
731 gettext "Creating"; echo -n " $WOK/$pkg"
732 mkdir $WOK/$pkg && cd $WOK/$pkg && status
733 gettext "Preparing the package receipt..."
734 cp $DATA/receipt .
735 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
736 status && echo ""
738 # Interactive mode, asking and seding.
739 case "$3" in
740 --interactive|-i)
741 echo "Entering interactive mode..."
742 echo "================================================================================"
743 echo "Package : $pkg"
744 # Version.
745 echo -n "Version : " ; read anser
746 sed -i s/'VERSION=\"\"'/"VERSION=\"$anser\""/ receipt
747 # Category.
748 echo -n "Category : " ; read anser
749 sed -i s/'CATEGORY=\"\"'/"CATEGORY=\"$anser\""/ receipt
750 # Short description.
751 echo -n "Short desc : " ; read anser
752 sed -i s/'SHORT_DESC=\"\"'/"SHORT_DESC=\"$anser\""/ receipt
753 # Maintainer.
754 echo -n "Maintainer : " ; read anser
755 sed -i s/'MAINTAINER=\"\"'/"MAINTAINER=\"$anser\""/ receipt
756 # Web site.
757 echo -n "Web site : " ; read anser
758 sed -i s#'WEB_SITE=\"\"'#"WEB_SITE=\"$anser\""# receipt
759 echo ""
760 # Wget URL.
761 echo "Wget URL to download source tarball."
762 echo "Example : \$GNU_MIRROR/\$PACKAGE/\$TARBALL"
763 echo -n "Wget url : " ; read anser
764 sed -i s#'WGET_URL=\"\"'#"WGET_URL=\"$anser\""# receipt
765 # Ask for a stuff dir.
766 echo -n "Do you need a stuff directory ? (y/N) : " ; read anser
767 if [ "$anser" = "y" ]; then
768 echo -n "Creating the stuff directory..."
769 mkdir $WOK/$pkg/stuff && status
770 fi
771 # Ask for a description file.
772 echo -n "Are you going to write a description ? (y/N) : " ; read anser
773 if [ "$anser" = "y" ]; then
774 echo -n "Creating the description.txt file..."
775 echo "" > $WOK/$pkg/description.txt && status
776 fi
777 echo "================================================================================"
778 echo "Receipt is ready to use."
779 echo "" ;;
780 esac ;;
781 list)
782 # Cook a list of packages (better use the Cooker since it will order
783 # packages before executing cook).
784 check_root
785 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
786 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
787 echo -e " $2\n" && exit 1
788 echo "Cook list starting: $2" | log
789 for pkg in $(cat $2)
790 do
791 cook $pkg || broken
792 done ;;
793 clean-wok)
794 check_root
795 gettext -e "\nCleaning all packages files..."
796 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
797 status && echo "" ;;
798 clean-src)
799 check_root
800 gettext -e "\nCleaning all packages sources..."
801 rm -rf $WOK/*/source
802 status && echo "" ;;
803 pkglist)
804 # Create suitable packages list for TazPKG and only for built packages.
805 [ "$2" ] && PKGS="$2"
806 [ ! -d "$PKGS" ] && \
807 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1
808 echo "cook:pkglist" > $command
809 echo "Cook pkglist: Creating all packages lists" | log
810 gettext -e "\nCreating lists for:"; echo " $PKGS"
811 separator
812 cd $PKGS
813 rm -f packages.*
814 gettext -e "Creating: packages.list\n"
815 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
816 gettext -e "Creating: packages.md5\n"
817 md5sum *.tazpkg > $PKGS/packages.md5
818 gettext -e "Creating: packages.desc\n"
819 gettext -e "Creating: packages.txt\n"
820 gettext -e "Creating: packages.equiv\n"
821 cd $WOK
822 for pkg in *
823 do
824 unset_receipt
825 . $pkg/receipt
826 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
827 # packages.desc lets us search easily in DB
828 cat >> $PKGS/packages.desc << EOT
829 $PACKAGE | $VERSION$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
830 EOT
831 # packages.txt used by tazpkg and tazpkg-web also to provide
832 # a human readable package list with version and description.
833 cat >> $PKGS/packages.txt << EOT
834 $PACKAGE
835 ${VERSION}$EXTRAVERSION
836 $SHORT_DESC
837 $PACKED_SIZE ($UNPACKED_SIZE installed)
839 EOT
840 # packages.equiv is used by tazpkg install to check depends.
841 for i in $PROVIDE; do
842 DEST=""
843 echo $i | fgrep -q : && DEST="${i#*:}:"
844 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
845 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
846 $PKGS/packages.equiv
847 else
848 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
849 fi
850 done
851 # files.list provides a list of all packages files.
852 cat $pkg/taz/*/files.list | sed s/^/"$pkg: \0"/ >> \
853 $PKGS/files.list
854 fi
855 done
856 cd $PKGS
858 # files.list.lzma
859 gettext -e "Creating: files.list.lzma\n"
860 lzma e files.list files.list.lzma
861 rm -f files.list
863 separator
864 nb=$(ls $PKGS/*.tazpkg | wc -l)
865 echo -e "Packages: $nb\n"
866 rm -f $command ;;
867 *)
868 # Just cook and generate a package.
869 check_root
870 time=$(date +%s)
871 pkg="$1"
872 [ -z "$pkg" ] && usage
873 receipt="$WOK/$pkg/receipt"
874 check_pkg_in_wok && echo ""
876 # Display and log info if cook process stopped.
877 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
878 tee -a $LOGS/$pkg.log' INT
880 # Skip blocked, 3 lines also for the Cooker.
881 if grep -q "^$pkg$" $blocked && [ "$2" != "--unblock" ]; then
882 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
883 fi
885 # Log and source receipt.
886 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
887 echo "cook:$pkg" > $command
888 unset inst
889 unset_receipt
890 . $receipt
892 # Handle --options
893 case "$2" in
894 --clean|-c)
895 gettext -e "Cleaning:"; echo -n " $pkg"
896 cd $WOK/$pkg && rm -rf install taz source
897 status && echo "" && exit 0 ;;
898 --install|-i)
899 inst='yes' ;;
900 --getsrc|-gs)
901 gettext "Getting source for:"; echo " $pkg"
902 separator && get_source
903 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
904 --block|-b)
905 gettext "Blocking:"; echo -n " $pkg"
906 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
907 status && echo "" && exit 0 ;;
908 --unblock|-ub)
909 gettext "Unblocking:"; echo -n " $pkg"
910 sed -i "/^${pkg}$/"d $blocked
911 status && echo "" && exit 0 ;;
913 esac
915 # Check if wanted is built now so we have separate log files.
916 if [ "$WANTED" ] && [ ! -d "$WOK/$WANTED/install" ]; then
917 if ! grep -q "^$WANTED$" $broken; then
918 cook "$WANTED"
919 fi
920 fi
922 # Cook and pack or exit on error and log everything.
923 cookit $@ 2>&1 | tee $LOGS/$pkg.log
924 remove_deps | tee -a $LOGS/$pkg.log
925 cookit_quality
926 packit 2>&1 | tee -a $LOGS/$pkg.log
927 clean_log
929 # Exit if any error in packing.
930 if grep -q ^ERROR $LOGS/$pkg.log; then
931 debug_info | tee -a $LOGS/$pkg.log
932 rm -f $command && exit 1
933 fi
935 # Time and summary
936 time=$(($(date +%s) - $time))
937 summary | tee -a $LOGS/$pkg.log
938 echo ""
940 # Install package if requested
941 if [ "$inst" ]; then
942 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
943 cd $PKGS && tazpkg install \
944 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
945 else
946 gettext -e "Unable to install package, build has failed.\n\n"
947 exit 1
948 fi
949 fi
950 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
951 # You want automation: use the Cooker Build Bot.
952 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
953 rm -f $command ;;
954 esac
956 exit 0